config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  resources :books
  get 'search_books' => 'books#search_books'

  resources :authors
  get 'search_authors' => 'authors#search_authors'

  resources :publishers
  get 'search_publishers' => 'publishers#search_publishers'

  root 'books#search_books'
end

app/models/publisher.rb
class Publisher < ApplicationRecord
  has_many :books, dependent: :destroy

  scope :find_all_by, -> (name, address) {
    @publisher_list = Publisher.all
    @publisher_list = @publisher_list.where("name LIKE ?", "%#{name}%" ) if name.present?
    @publisher_list = @publisher_list.where("address LIKE ?", "%#{address}%" ) if address.present?
  }

  validates :name, :presence => {:message => "Kérjük, válasszon ki egy nevet!" }
  validates :address, :presence => {:message => "Kérjük, válasszon ki egy címet!" }

  def full_publisher_name
    "#{name}"
  end

end

app/controllers/publishers_controller.rb
class PublishersController < ApplicationController

  include CheckValues
  include InitializeValues

  before_action { initialize_params(title = "Kiadó keresése", @publisher_list = Publisher.all) unless @clicked }
  before_action :set_publisher, only: [:show, :edit, :update, :destroy]
  helper_method :calculate_page_idx_upper_bound, :check_boundaries, :convert_to_int

  def search_publishers
    name = params[:name]
    address = params[:address]

    @per_page = convert_to_int(params[:per_page].to_i, 5)
    @per_page = 5 if @per_page.blank? || @per_page > 10 || @per_page < 3

    @current_page = convert_to_int(params[:page].to_i, 1)
    @current_page = check_boundaries(@current_page, calculate_page_idx_upper_bound(@publisher_list.count, @per_page))

    @clicked = is_clicked?(name, address)

    @publisher_list = Publisher.where("name LIKE ?", "%#{name}%") if name.present?
    @publisher_list = @publisher_list.where("address LIKE ?", "%#{address}%") if address.present?
    @publisher_list = @publisher_list.paginate(:page => @current_page, :per_page => @per_page)

    respond_to do |format|
      format.html { render :search_publishers }
      format.xml { render :xml => @publisher_list }
      format.json { render :json => @publisher_list }
    end
  end

  # felugro ablak(modal) megnyitasa uj oldal helyett
  def show
    respond_to do |format|
      format.js
    end
  end

  def edit; end

  def new
    @publisher = Publisher.new
  end

  def create
    @publisher = Publisher.new(valid_params)
    @publisher.id = Publisher.all.pluck(:id).max + 1
    if @publisher.save
      redirect_to search_publishers_path, notice: "A szerző <b>(#{h @publisher.name})</b> létrehozása sikeresen megtörtént!".html_safe
    else
      render :new
    end
  end

  def update
    if @publisher.update(valid_params)
      redirect_to search_publishers_path, notice: "A szerző <b>(#{h @publisher.name})</b> módosítása sikeresen megtörtént!".html_safe
    else
      render :edit
    end
  end

  def destroy
    @publisher.destroy
    redirect_to search_publishers_path, notice: "A szerző <b>(#{h @publisher.name})</b> törlése sikeresen megtörtént!".html_safe
  end

  private

  def valid_params
    params.require(:publisher).permit(:name, :address)
  end

  # edit, destroy, update, show előtt lefutó metódus, amely a kódduplikálás ellen van
  def set_publisher
    @publisher = Publisher.find_by_id(params[:id])
  end

end

app/helpers/publisher_helper.rb
module PublisherHelper

  include ApplicationHelper

  def show_message(name, address)
    msg = "<div class='alert alert-danger'>Nincs találat a következő kifejezésre: "
    msg +=  "<br>Név: <b>#{h name}</b>" unless name.blank?
    msg +=  "<br>Cím: <b>#{h address}</b>" unless address.blank?
    msg += "</div>"
    msg.html_safe
  end

end

app/views/publishers/_form.html.erb
<%= form_with(model: @publisher, local: true) do |f| %>
  <div class="form-group">
    <%= render "shared/errors", object: @publisher %>
    <table class="table" style="align-content: center" style="width: 1000px">
      <tr>
        <td style = "width: 100%">
          <%= f.label :name, "Kiadó neve" %><br>
          <%= f.text_field :name, autofocus: true, placeholder: "Kiadó neve", class: "form-control" %><br>
        </td>
      </tr>

      <tr>
        <td>
          <%= f.label :address, "Cím" %><br>
          <%= f.text_field :address, placeholder: "Lakcím", class: "form-control" %><br>
        </td>
      </tr>
    </table>
    <%= f.submit "Mentés", class: "btn btn-success" %>
    <%= link_to 'Mégsem', search_publishers_path, class: 'btn btn-danger' %>
    <div style="text-align: right; margin-top: -35px"> <%= link_to 'Vissza a kereséshez', search_publishers_path, class: 'btn btn-primary' %> </div>
  </div>
<% end %>

app/views/publishers/_publisher_modal.html.erb
<div id="publisher-modal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <!--<button type="button" class="close" data-dismiss="modal">&times;</button>-->
        <h3 class="modal-title" style="text-align: left">Kiadó megtekintése</h3>
      </div>

      <div class="modal-body">
        <p> Név: <span style="color: dodgerblue; "> <%=h @publisher.name %> </span> </p>
        <p> Cím: <span style="color: dodgerblue; "> <%=h @publisher.address %> </span> </p>
      </div>

      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Bezárás</button>
      </div>
    </div>
  </div>
</div>

app/views/publishers/edit.html.erb
<h1>Szerkesztés - <%= @publisher.name %></h1><br><br>
<%= render "form", publisher: @publisher %>

app/views/publishers/new.html.erb
<h1>Kiadó hozzáadása </h1><br><br>
<%= render "form", publisher: @publisher %>

app/views/publishers/search_publishers.html.erb
<div>
  <%= successful_action_msg(notice) %>
  <%= link_to 'Új könyv felvétele', new_book_path, class: 'btn btn-success' %>
  <%= link_to 'Új szerző felvétele', new_author_path, class: 'btn btn-success' %>
  <%= link_to 'Új kiadó felvétele', new_publisher_path, class: 'btn btn-success' %><br><br>

  <%= form_tag search_publishers_path, :method => "get" do %>
    <div class="form-group">
      <label><b>Kiadó keresése</b> - Szűrési feltételek </label>
      <table class="table" style="align-content: center">
        <tr>
          <td style="width: 50%"><%= text_field_tag(:name, params[:name], placeholder: "Kiadó neve", class: "form-control") %></td>
          <td style="width: 50%"><%= text_field_tag(:address, params[:address], placeholder: "Cím", class: "form-control") %></td>
        </tr>

        <tr>
          <td colspan="2" style="width: 10%" >
            Találatok oldalanként
            <input id="per_page" name="per_page" min="3" max="10" type="number" class="form-control" value="<%= @per_page %>" style="width: 60px"/>
          </td>
        </tr>

        <tr>
          <td>
            <%= submit_tag "Keresés", class: "btn btn-primary" %>
          </td>
        </tr>
      </table>

    </div>
  <% end %>

  <% if @publisher_list.count == 0 %>
    <table class="table">
      <tr>
        <td scope="row">
          <%= show_message(params[:name], params[:address]) %>
        </td>
      </tr>
    </table>
  <% end %>

  <% unless @publisher_list.nil? || @publisher_list.empty? %>
    <table>
      <tr>
        <th scope="row">
          Találatok száma: <span style = "color: green"> <%= @publisher_list.count %> </span>
        </th>
      </tr>
    </table>
    <br>
    <table class="table">
      <thead>
      <tr>
        <th scope="col">#</th>
        <th scope="col">Kiadó neve</th>
        <th scope="col">Kiadó címe</th>
        <th scope="col" colspan="3" width="25%" style="text-align:center">Műveletek</th>
      </tr>
      </thead>
      <tbody>

      <% list_size = @publisher_list.count %>
      <% @publisher_list.each_with_index do |publisher, idx| %>
        <%= set_row_background(idx) %>
        <th scope="row"> <%= current_index(idx, list_size, @current_page, @per_page) %> </th>
        <td> <%= publisher.name if publisher %> </td>
        <td> <%= publisher.address if publisher %> </td>
        <td> <%= link_to 'Megtekintés',  publisher_path(publisher.id), remote: true, class: 'btn btn-info' %> </td>
        <td> <%= link_to 'Szerkesztés', edit_publisher_path(publisher.id), class: 'btn btn-warning'%> </td>
        <td> <%= link_to 'Törlés', publisher_path(publisher.id),
                         class: 'btn btn-danger',
                         method: :delete,
                         data: { confirm: "Biztosan törli a következőt?\n
    Cím: #{publisher.name}
    ISBN: #{publisher.address}"} %></td>
        </tr>
      <% end %>
      </tbody>
    </table>
  <% end %>
</div>

<div class="row">
  <div class="col offset-4">
    <!-- ez a kódrészlet felel az egyes aloldalak linkként való megjelenítéséért -->
    <%= will_paginate @publisher_list, :previous_label => 'Előző', :next_label => 'Következő', renderer: WillPaginate::ActionView::Bootstrap4LinkRenderer %>
  </div>
</div>

<!-- MODAL MEGNYITASA JS-sel - megtekintés -->
<div id='publisher-content'></div>

<!-- https://dev.to/morinoko/adding-custom-javascript-in-rails-6-1ke6 -->
<%= javascript_pack_tag 'message_alerts' %>

app/views/publishers/show.js.erb
$('#publisher-content').html("<%= j render 'publisher_modal', publisher: @publisher %>");
$('#publisher-modal').modal('show');